#include <stdio.h>
#include <stdlib.h>

void print_bits(int x)
{
	//kako da izvucemo zadnji bit (desni)
	//uvek pravimo masku
	//maska = 0000...000001
	//int maska = 1;
	//bilo_koji_broj & maska
	//tamo gde su 0 u maski bice 0, a tamo gde je 1 bice zadnji bit iz
	//bilo_koji_broj
	
	//int a = maska & x;
	//if(a == 0)
		//zadnji bit je 0
	//else
		//zadnju bit je 1
	
	//posto stampamo od skroz levog bita
	//maska treba da bude 10000...0000
	int bits_count = 8 * sizeof(unsigned int);
	unsigned int maska = 1 << (bits_count - 1);
	int i;
	for(i = 0; i < bits_count; i++)
	{
		unsigned int r = maska & x;
		//r = 100000000000000
		if(r == 0)
			putchar('0');
		else
			putchar('1');
		//dve opcije
		//maska = maska >> 1;
		//x = x << 1;
		maska = maska >> 1;
	}
	putchar('\n');
}

int jedinica_na_mestu_k(int x, int k)
{
	//k-to mesto sa desna na levo, pocevsi od 0
	//00000000000001 - 1 na 0-tom mestu
	//00000000000010 - 1 na 1-vom mestu
	
	//0000001000000 - maska, a da se 1 nalazi na mestu k
	
	unsigned maska = 1 << k;
	
	unsigned r = maska & x;
	if(r == 0)
		return 0;
	else 
		return 1;
}

int postavi_na_mesto_k_jedan(int x, int k)
{
	//kao rezultat vracamo novi int u kome je postavljena jedinica
	unsigned maska = 1 << k;
	//0000010000000
	//abcdefghijklm
	//abcde1ghijklm
	
	return x | maska;
	
}

int suma_bitova(int x)
{
	int rez = 0;
	int bits_count = 8 * sizeof(unsigned int);
	unsigned int maska = 1 << (bits_count - 1);
	int i;
	for(i = 0; i < bits_count; i++)
	{
		unsigned int r = maska & x;
		if(r != 0)
			rez++;
		maska = maska >> 1;
	}
	return rez;
}

unsigned get_bits(int x, int p, int n)
{
	//000011110000
	//~0 = 111111111111					~0
	//(~0) << n = 111111000000			<<n
	//~((~0) << n) = 0000001111			~
	//(~((~0) << n))<<p = 0001111000	<<p
	
	unsigned maska = (~((~0) << n))<<p;
	//test
	//print_bits(maska);
	
	unsigned r = x & maska;
	return r >> p;
}
unsigned set_bits(unsigned x, int p, int n, unsigned y)
{
	unsigned maska = ~((~((~0) << n))<<p); //11110000011111
	x = x & maska;
	
	maska = ~((~0)<<n);
	y = y & maska;
	y = y << p;
	return x | y;
}

unsigned invert_bits(unsigned x, int p, int n)
{
	//0000001111110000000
	unsigned maska = (~((~0) << n))<<p;
	return x ^ maska;
}

int main()
{
	int x;
	scanf("%d", &x);
	
	print_bits(x);
	
	int n, p;
	scanf("%d%d", &n, &p);
	
	print_bits(invert_bits(x, p, n));
	
	/******zadaci 5-6
	int y;
	scanf("%d", &y);
	
	print_bits(x);
	print_bits(y);
	
	int n, p;
	scanf("%d%d", &n, &p);
	//print_bits(get_bits(x, p, n));
	print_bits(set_bits(x, p, n, y));
	***********************/
	
	/******zadaci 1-4 
	int k;
	scanf("%d", &k);
	if(jedinica_na_mestu_k(x, k))
		printf("jedinica\n");
	else
		printf("nula\n");
		
	x = postavi_na_mesto_k_jedan(x, k);
	print_bits(x);
	
	printf("suma bitova: %d\n", suma_bitova(x));
	**********/
	

	
}